IF NOT EXISTS (SELECT * FROM SYS.TABLES WHERE NAME = 'RC_CLI_BEM_MAIS_PRC_BANDEIRA')
BEGIN

CREATE TABLE [DBO].[RC_CLI_BEM_MAIS_PRC_BANDEIRA](
	[CD_EMP]				INT NOT NULL,
	[CD_CLI]				INT NOT NULL,
	[CD_BANDEIRA]			INT NOT NULL,
	[DES_SIGLA]				VARCHAR(100),
	[FLAG_REGULAMENTO]		INT,
	[FLAG_EMAIL]			INT,
	[FLAG_SMS]				INT,
	[EST_CIVIL]				VARCHAR(20),
	[FLAG_CONC_DESC]		INT,
	[DES_MOT_CONS_DESC]		VARCHAR(100),
	[DT_ULT_DESC]	DATE	
	CONSTRAINT PK_RC_CLI_BEM_MAIS_PRC_BANDEIRA PRIMARY KEY CLUSTERED ([CD_EMP], [CD_CLI], [CD_BANDEIRA])
) ON [PRIMARY]

END
GO

IF NOT EXISTS (SELECT * FROM SYS.FOREIGN_KEYS WHERE NAME = 'FK_RC_CLI_BEM_MAIS_PRC_BANDEIRA_PRC_BANDEIRA')
BEGIN
	ALTER TABLE RC_CLI_BEM_MAIS_PRC_BANDEIRA ADD CONSTRAINT FK_RC_CLI_BEM_MAIS_PRC_BANDEIRA_PRC_BANDEIRA FOREIGN KEY (CD_BANDEIRA) REFERENCES PRC_BANDEIRA (CD_BANDEIRA)
END
GO

ALTER TABLE RC_CLI_BEM_MAIS_PRC_BANDEIRA CHECK CONSTRAINT FK_RC_CLI_BEM_MAIS_PRC_BANDEIRA_PRC_BANDEIRA
GO

IF NOT EXISTS (SELECT * FROM SYS.FOREIGN_KEYS WHERE NAME = 'FK_RC_CLI_BEM_MAIS_PRC_BANDEIRA_RC_CLI_BEM_MAIS')
BEGIN
	ALTER TABLE RC_CLI_BEM_MAIS_PRC_BANDEIRA ADD CONSTRAINT FK_RC_CLI_BEM_MAIS_PRC_BANDEIRA_RC_CLI_BEM_MAIS FOREIGN KEY (CD_EMP, CD_CLI) REFERENCES RC_CLI_BEM_MAIS (CD_EMP, CD_CLI)
END
GO

ALTER TABLE RC_CLI_BEM_MAIS_PRC_BANDEIRA CHECK CONSTRAINT FK_RC_CLI_BEM_MAIS_PRC_BANDEIRA_RC_CLI_BEM_MAIS
GO
