IF EXISTS
(
    SELECT 1
    FROM SYS.VIEWS
    WHERE NAME = 'V_EST_PARAM_COMPRAS_GRUPO_CURVA_PARAMETRO_COMPRAS'
)
    BEGIN
        DROP VIEW V_EST_PARAM_COMPRAS_GRUPO_CURVA_PARAMETRO_COMPRAS;
    END;
GO
--SELECT DISTINCT CD_CTR FROM V_EST_PARAM_COMPRAS_GRUPO_CURVA_PARAMETRO_COMPRAS WHERE PROXIMA_REVISAO_PARETO='2018-05-07'
CREATE VIEW V_EST_PARAM_COMPRAS_GRUPO_CURVA_PARAMETRO_COMPRAS 
AS
SELECT 
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_CATEGORIA.CD_CTR,
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_CATEGORIA.CD_GRUPO_CURVA,
	COALESCE(DATEADD(DAY,FREVISAOPARETO, EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.DT_ULTIMA_REVISAO_PARETO),CONVERT(CHAR(10),GETDATE(),112))  AS PROXIMA_REVISAO_PARETO
	,'CATEGORIA' AS DS_TIPO
FROM 
	EST_PARAM_COMPRAS_GRUPO_CURVA INNER JOIN EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_CATEGORIA ON
	EST_PARAM_COMPRAS_GRUPO_CURVA.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_CATEGORIA.CD_GRUPO_CURVA
	LEFT OUTER JOIN EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO ON
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_CATEGORIA.CD_CTR = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_CTR_COMPRAS_GRUPO  AND
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_CATEGORIA.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_GRUPO_CURVA
UNION 
SELECT 
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_FAMILIA.CD_CTR,
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_FAMILIA.CD_GRUPO_CURVA,
	COALESCE(DATEADD(DAY,FREVISAOPARETO, EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.DT_ULTIMA_REVISAO_PARETO),CONVERT(CHAR(10),GETDATE(),112))  AS PROXIMA_REVISAO_PARETO
	,'FAMILIA' AS DS_TIPO

FROM 
	EST_PARAM_COMPRAS_GRUPO_CURVA INNER JOIN EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_FAMILIA ON
	EST_PARAM_COMPRAS_GRUPO_CURVA.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_FAMILIA.CD_GRUPO_CURVA
	LEFT OUTER JOIN EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO ON
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_FAMILIA.CD_CTR = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_CTR_COMPRAS_GRUPO  AND
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_FAMILIA.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_GRUPO_CURVA
UNION 
SELECT 
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_LINHA.CD_CTR,
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_LINHA.CD_GRUPO_CURVA,
	COALESCE(DATEADD(DAY,FREVISAOPARETO, EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.DT_ULTIMA_REVISAO_PARETO),CONVERT(CHAR(10),GETDATE(),112))  AS PROXIMA_REVISAO_PARETO
	,'LINHA' AS DS_TIPO

FROM 
	EST_PARAM_COMPRAS_GRUPO_CURVA INNER JOIN EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_LINHA ON
	EST_PARAM_COMPRAS_GRUPO_CURVA.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_LINHA.CD_GRUPO_CURVA
	LEFT OUTER JOIN EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO ON
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_LINHA.CD_CTR = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_CTR_COMPRAS_GRUPO  AND
	EST_PARAM_COMPRAS_GRUPO_EST_ARV_MERC_LINHA.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_GRUPO_CURVA
UNION 
SELECT 
	EST_PARAM_COMPRAS_GRUPO_EST_MC.CD_CTR,
	EST_PARAM_COMPRAS_GRUPO_EST_MC.CD_GRUPO_CURVA,
	COALESCE(DATEADD(DAY,FREVISAOPARETO, EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.DT_ULTIMA_REVISAO_PARETO),CONVERT(CHAR(10),GETDATE(),112))  AS PROXIMA_REVISAO_PARETO
	,'MARCA' AS DS_TIPO
FROM 
	EST_PARAM_COMPRAS_GRUPO_CURVA INNER JOIN EST_PARAM_COMPRAS_GRUPO_EST_MC ON
	EST_PARAM_COMPRAS_GRUPO_CURVA.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_EST_MC.CD_GRUPO_CURVA
	LEFT OUTER JOIN EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO ON
	EST_PARAM_COMPRAS_GRUPO_EST_MC.CD_CTR = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_CTR_COMPRAS_GRUPO  AND
	EST_PARAM_COMPRAS_GRUPO_EST_MC.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_GRUPO_CURVA
UNION 
SELECT 
	EST_PARAM_COMPRAS_GRUPO_EST_PROD.CD_CTR,
	EST_PARAM_COMPRAS_GRUPO_EST_PROD.CD_GRUPO_CURVA,
	COALESCE(DATEADD(DAY,FREVISAOPARETO, EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.DT_ULTIMA_REVISAO_PARETO),CONVERT(CHAR(10),GETDATE(),112))  AS PROXIMA_REVISAO_PARETO
	,'PRODUTO' AS DS_TIPO
FROM 
	EST_PARAM_COMPRAS_GRUPO_CURVA INNER JOIN EST_PARAM_COMPRAS_GRUPO_EST_PROD ON
	EST_PARAM_COMPRAS_GRUPO_CURVA.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_EST_PROD.CD_GRUPO_CURVA
	LEFT OUTER JOIN EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO ON
	EST_PARAM_COMPRAS_GRUPO_EST_PROD.CD_CTR = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_CTR_COMPRAS_GRUPO  AND
	EST_PARAM_COMPRAS_GRUPO_EST_PROD.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_GRUPO_CURVA
UNION 
SELECT 
	EST_PARAM_COMPRAS_GRUPO_EST_PROD_FABRIC.CD_CTR,
	EST_PARAM_COMPRAS_GRUPO_EST_PROD_FABRIC.CD_GRUPO_CURVA,
	COALESCE(DATEADD(DAY,FREVISAOPARETO, EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.DT_ULTIMA_REVISAO_PARETO),CONVERT(CHAR(10),GETDATE(),112))  AS PROXIMA_REVISAO_PARETO
	,'FABRICANTE' AS DS_TIPO
FROM 
	EST_PARAM_COMPRAS_GRUPO_CURVA INNER JOIN EST_PARAM_COMPRAS_GRUPO_EST_PROD_FABRIC ON
	EST_PARAM_COMPRAS_GRUPO_CURVA.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_EST_PROD_FABRIC.CD_GRUPO_CURVA
	LEFT OUTER JOIN EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO ON
	EST_PARAM_COMPRAS_GRUPO_EST_PROD_FABRIC.CD_CTR = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_CTR_COMPRAS_GRUPO  AND
	EST_PARAM_COMPRAS_GRUPO_EST_PROD_FABRIC.CD_GRUPO_CURVA = EST_PARAM_COMPRAS_GRUPO_CURVA_PARETO_PROC_ULTIMO.CD_GRUPO_CURVA