IF NOT OBJECT_ID('EST_COMPRADOR_MOVIMENTACAO_CPL') IS NULL
BEGIN
	DROP TABLE EST_COMPRADOR_MOVIMENTACAO_CPL
END

CREATE TABLE [dbo].[EST_COMPRADOR_MOVIMENTACAO_CPL](
	[CD_CTR] [int] NOT NULL,
	[CD_EMP] [int] NOT NULL,
	[CD_FILIAL] [int] NOT NULL,
	[CD_PG_CRED] [int] NOT NULL,
	[CD_PROD] [int] NOT NULL,
	[DT_EMIS] [datetime] NOT NULL,
	[DT_VENCTO] [datetime] NOT NULL,
	[VLR_DP] [money] NOT NULL,
	[VLR_JUROS] [money] NOT NULL,
	[VLR_DESC] [money] NOT NULL,
	[VLR_DESP_OUTR] [money] NOT NULL,
	[VLR_DEVOLUCAO] [money] NOT NULL,
	[CD_FORN] [int] NOT NULL,
	[CD_TP_FORN] [int] NOT NULL,
 CONSTRAINT [PK_EST_COMPRADOR_MOVIMENTACAO_CPL] PRIMARY KEY CLUSTERED 
(
	[CD_CTR] ASC,
	[CD_EMP] ASC,
	[CD_FILIAL] ASC,
	[CD_PG_CRED] ASC,
	[CD_PROD] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

ALTER TABLE [dbo].[EST_COMPRADOR_MOVIMENTACAO_CPL] ADD  CONSTRAINT [DF_EST_COMPRADOR_MOVIMENTACAO_CPL_VLR_DP]  DEFAULT ((0)) FOR [VLR_DP]

ALTER TABLE [dbo].[EST_COMPRADOR_MOVIMENTACAO_CPL] ADD  CONSTRAINT [DF_EST_COMPRADOR_MOVIMENTACAO_CPL_VLR_JUROS]  DEFAULT ((0)) FOR [VLR_JUROS]

ALTER TABLE [dbo].[EST_COMPRADOR_MOVIMENTACAO_CPL] ADD  CONSTRAINT [DF_EST_COMPRADOR_MOVIMENTACAO_CPL_VLR_DESC]  DEFAULT ((0)) FOR [VLR_DESC]

ALTER TABLE [dbo].[EST_COMPRADOR_MOVIMENTACAO_CPL] ADD  CONSTRAINT [DF_EST_COMPRADOR_MOVIMENTACAO_CPL_VLR_DESP_OUTR]  DEFAULT ((0)) FOR [VLR_DESP_OUTR]

ALTER TABLE [dbo].[EST_COMPRADOR_MOVIMENTACAO_CPL] ADD  CONSTRAINT [DF_EST_COMPRADOR_MOVIMENTACAO_CPL_VLR_DEVOLUCAO]  DEFAULT ((0)) FOR [VLR_DEVOLUCAO]

ALTER TABLE [dbo].[EST_COMPRADOR_MOVIMENTACAO_CPL] ADD  CONSTRAINT [DF_EST_COMPRADOR_MOVIMENTACAO_CPL_CD_FORN]  DEFAULT ((0)) FOR [CD_FORN]

ALTER TABLE [dbo].[EST_COMPRADOR_MOVIMENTACAO_CPL] ADD  CONSTRAINT [DF_EST_COMPRADOR_MOVIMENTACAO_CPL_CD_TP_FORN]  DEFAULT ((0)) FOR [CD_TP_FORN]

ALTER TABLE [dbo].[EST_COMPRADOR_MOVIMENTACAO_CPL]  WITH CHECK ADD  CONSTRAINT [FK_EST_COMPRADOR_MOVIMENTACAO_CPL_EST_COMPRADOR_MOVIMENTACAO] FOREIGN KEY([CD_CTR])
REFERENCES [dbo].[EST_COMPRADOR_MOVIMENTACAO] ([CD_CTR])
ON UPDATE CASCADE
ON DELETE CASCADE

ALTER TABLE [dbo].[EST_COMPRADOR_MOVIMENTACAO_CPL] CHECK CONSTRAINT [FK_EST_COMPRADOR_MOVIMENTACAO_CPL_EST_COMPRADOR_MOVIMENTACAO]
