

IF NOT EXISTS (SELECT * FROM SYS.TABLES WHERE NAME = 'PDV_CX_NFCE_CERTIFICADO' )

BEGIN 
	CREATE TABLE PDV_CX_NFCE_CERTIFICADO (
	    CD_CTR		    INT IDENTITY (1,1),
		CD_FILIAL		INT NOT NULL,
	    CNPJ			VARCHAR(14)  COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS,
	    UF				VARCHAR(2)   COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS,
	    CHAVE			VARCHAR(128) COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS,
	    LICENCA			VARCHAR(512) COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS,
	    EMPRESA			VARCHAR(50)  COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS, 
	    SERIE			VARCHAR(50)  COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS,
	    PIN_CERT		VARCHAR(50)  COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS,
	    ID_TOKEN		VARCHAR(50)  COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS,
	    CSC_TOKEN		VARCHAR(200) COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS,
	    ARQ_CERTIFICADO VARBINARY(MAX),
	    PIN_TOKEN       VARCHAR(100) COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS CONSTRAINT DF_PDV_CX_NFCE_CERTIFICADO_PIN_TOKEN DEFAULT '',
	    ATIVACAO_SAT    VARCHAR(20)  COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS CONSTRAINT DF_PDV_CX_NFCE_CERTIFICADO_ATIVACAO_SAT DEFAULT '' NOT NULL,
	    FABRICANTE_SAT  SMALLINT     CONSTRAINT DF_PDV_CX_NFCE_CERTIFICADO_FABRICANTE_SAT DEFAULT 0  NOT NULL,
	    SIGN_SAT		VARCHAR(400) COLLATE SQL_LATIN1_GENERAL_CP1_CI_AS CONSTRAINT DF_PDV_CX_NFCE_CERTIFICADO_SIGN_SAT DEFAULT ''  NOT NULL
	    
	)
	ALTER TABLE PDV_CX_NFCE_CERTIFICADO	ADD CONSTRAINT PK_PDV_CX_NFCE_CERTIFICADO PRIMARY KEY (CD_CTR);
END ; 


