 
IF EXISTS
(
    SELECT *
    FROM sys.views
    WHERE object_id = OBJECT_ID(N'[dbo].[V_PDV_VD_AUDIT]')
)
    DROP VIEW [dbo].[V_PDV_VD_AUDIT];
GO
GO

--SELECT * FROM V_PDV_VD_AUDIT WHERE CD_EMP = 1 AND  DT_CAD = '2017-10-10'
CREATE VIEW [dbo].[V_PDV_VD_AUDIT]
WITH ENCRYPTION
AS
     SELECT DISTINCT
            PDV_VD.CD_EMP,
            PDV_VD.CD_FILIAL,
            PDV_VD_DEV_NCC.CD_CTR_NCC,
            PDV_VD.CD_FILIAL AS CD_FILIAL_GEROU,
            PDV_VD_DEV_NCC.VLR_NCC AS VLR_DEVOLVIDO,
            GLB_USU.NM_USU,
            PDV_VD_DEV_NCC.DT_CAD,
            PDV_VD_DEV_NCC.STS_NCC,
            PDV_VD.DT_VD,
            PDV_VD.NR_ECF AS NR_ECF_GEROU,
            PDV_VD.CD_CX AS CX_GEROU,
            PDV_VD.VLR_LIQ_VD AS VLR_LIQ_VENDA_GEROU,
            RC_CLI.CD_CLI,
            ISNULL(dbo.RC_CLI.RZ_CLI, '') AS NM_CLI_GEROU,
            STS_NCC AS CD_MODALIDADE,
            V_PDV_VD_DEV_NCC_STATUS.DS_STS_NCC AS MODALIDADE,
            NULL AS DT_VD_CRED_NCC,
            '' AS NR_DOCUMENTO,
            0 AS CD_CX_CRED_NCC,
            0 AS VLR_LIQ_VD,
            0 AS CD_CLI_CRED_NCC,
            '' AS NM_CLI_USOU,
            0 AS CD_REGI,
            ISNULL(PDV_VD.CD_CONV, 0) AS CD_CONV,  -- select * from V_PDV_VD_DEV_NCC_STATUS
            0 AS VLR_NCC_USADO,
			PDV_VD_DEV_NCC.DT_CAD_REGISTRO,
			PDV_VD_DEV_NCC.TIPO_NCC
     FROM PDV_VD_DEV_NCC
          INNER JOIN PDV_VD_DEV_NCC_PDV_VD_DEV_EST_PROD_IMP AS NCC_DEV ON PDV_VD_DEV_NCC.CD_CTR_NCC = NCC_DEV.CD_CTR_NCC
          INNER JOIN PDV_VD ON NCC_DEV.CD_EMP = PDV_VD.CD_EMP
                               AND NCC_DEV.CD_FILIAL = PDV_VD.CD_FILIAL
                               AND NCC_DEV.CD_VD = PDV_VD.CD_VD
          INNER JOIN dbo.RC_CLI ON PDV_VD.CD_EMP = RC_CLI.CD_EMP
                                   AND PDV_VD.CD_CLI = RC_CLI.CD_CLI
          INNER JOIN dbo.GLB_USU ON PDV_VD_DEV_NCC.CD_USU = GLB_USU.CD_USU
          INNER JOIN V_PDV_VD_DEV_NCC_STATUS ON PDV_VD_DEV_NCC.STS_NCC = V_PDV_VD_DEV_NCC_STATUS.CD_STS_NCC
     WHERE PDV_VD_DEV_NCC.STS_NCC IN(0, 2, 3, 5)
     UNION ALL
     SELECT DISTINCT
            EST_NF_ENT.CD_EMP,
            EST_NF_ENT.CD_FILIAL,
            PDV_VD_DEV_NCC.CD_CTR_NCC,
            EST_NF_ENT.CD_FILIAL AS CD_FILIAL_GEROU,
            PDV_VD_DEV_NCC.VLR_NCC AS VLR_DEVOLVIDO,
            GLB_USU.NM_USU,
            PDV_VD_DEV_NCC.DT_CAD,
            PDV_VD_DEV_NCC.STS_NCC,
            EST_NF_ENT.DT_ENT AS DT_VD,
            EST_NF_ENT.NR_NF AS NR_ECF_GEROU,
            0 AS CX_GEROU,
            EST_NF_ENT.VLR_NF AS VLR_LIQ_VENDA_GEROU,
            RC_CLI.CD_CLI,
            ISNULL(RC_CLI.RZ_CLI, '') AS NM_CLI_GEROU,
            STS_NCC AS CD_MODALIDADE,
            V_PDV_VD_DEV_NCC_STATUS.DS_STS_NCC AS MODALIDADE,
            NULL AS DT_VD_CRED_NCC,
            '' AS NR_DOCUMENTO,
            0 AS CD_CX_CRED_NCC,
            0 AS VLR_LIQ_VD,
            0 AS CD_CLI_CRED_NCC,
            '' AS NM_CLI_USOU,
            0 AS CD_REGI,
            0 AS CD_CONV,
            0 AS VLR_NCC_USADO,
			PDV_VD_DEV_NCC.DT_CAD_REGISTRO,
			PDV_VD_DEV_NCC.TIPO_NCC
     FROM PDV_VD_DEV_NCC
          INNER JOIN EST_NF_ENT_PDV_VD_DEV_NCC AS NCC_DEV ON PDV_VD_DEV_NCC.CD_CTR_NCC = NCC_DEV.CD_CTR_NCC
          INNER JOIN EST_NF_ENT ON EST_NF_ENT.CD_EMP = NCC_DEV.CD_EMP
                                   AND EST_NF_ENT.CD_FILIAL = NCC_DEV.CD_FILIAL
                                   AND EST_NF_ENT.CD_NF = NCC_DEV.CD_NF
          INNER JOIN RC_CLI ON RC_CLI.CD_CLI = PDV_VD_DEV_NCC.CD_CLI
          INNER JOIN dbo.GLB_USU ON PDV_VD_DEV_NCC.CD_USU = GLB_USU.CD_USU
          INNER JOIN V_PDV_VD_DEV_NCC_STATUS ON PDV_VD_DEV_NCC.STS_NCC = V_PDV_VD_DEV_NCC_STATUS.CD_STS_NCC
     WHERE PDV_VD_DEV_NCC.STS_NCC IN(0, 2, 3, 5)
     UNION ALL
     SELECT DISTINCT
            PDV_VD.CD_EMP,
            PDV_VD.CD_FILIAL,
            PDV_VD_DEV_NCC.CD_CTR_NCC,
            PDV_VD.CD_FILIAL AS CD_FILIAL_GEROU,
            PDV_VD_DEV_NCC.VLR_NCC AS VLR_DEVOLVIDO,
            GLB_USU.NM_USU,
            PDV_VD_DEV_NCC.DT_CAD,
            PDV_VD_DEV_NCC.STS_NCC,
            PDV_VD.DT_VD,
            PDV_VD.NR_ECF AS NR_ECF_GEROU,
            PDV_VD.CD_CX AS CX_GEROU,
            PDV_VD.VLR_LIQ_VD AS VLR_LIQ_VENDA_GEROU,
            RC_CLI.CD_CLI,
            ISNULL(dbo.RC_CLI.RZ_CLI, '') AS NM_CLI_GEROU,
            STS_NCC AS CD_MODALIDADE,
            V_PDV_VD_DEV_NCC_STATUS.DS_STS_NCC AS MODALIDADE,
            PDV_VD_NOVO.DT_VD AS DT_VD_CRED_NCC,
            CONVERT(VARCHAR(10),PDV_VD_NOVO.NR_ECF) AS NR_DOCUMENTO,
            PDV_VD_NOVO.CD_CX AS CD_CX_CRED_NCC,
            PDV_VD_NOVO.VLR_LIQ_VD AS VLR_LIQ_VD,
            0 AS CD_CLI_CRED_NCC,
            RC_CLI_NOVO.NM_FANT AS NM_CLI_USOU,
            ISNULL(RC_CLI_NOVO.CD_REGI, 0) AS CD_REGI,
            ISNULL(PDV_VD.CD_CONV, 0) AS CD_CONV,
            PDV_VD_NOVO.VLR_NCC AS VLR_NCC_USADO,
			PDV_VD_DEV_NCC.DT_CAD_REGISTRO,
			PDV_VD_DEV_NCC.TIPO_NCC
     FROM PDV_VD_DEV_NCC
          INNER JOIN PDV_VD_DEV_NCC_PDV_VD_DEV_EST_PROD_IMP AS NCC_DEV ON PDV_VD_DEV_NCC.CD_CTR_NCC = NCC_DEV.CD_CTR_NCC
          INNER JOIN PDV_VD ON NCC_DEV.CD_EMP = PDV_VD.CD_EMP
                               AND NCC_DEV.CD_FILIAL = PDV_VD.CD_FILIAL
                               AND NCC_DEV.CD_VD = PDV_VD.CD_VD
          INNER JOIN dbo.RC_CLI ON PDV_VD.CD_EMP = RC_CLI.CD_EMP
                                   AND PDV_VD.CD_CLI = RC_CLI.CD_CLI
          INNER JOIN dbo.GLB_USU ON PDV_VD_DEV_NCC.CD_USU = GLB_USU.CD_USU
          INNER JOIN V_PDV_VD_DEV_NCC_STATUS ON PDV_VD_DEV_NCC.STS_NCC = V_PDV_VD_DEV_NCC_STATUS.CD_STS_NCC
          INNER JOIN PDV_VD_DEV_NCC_PDV_VD ON PDV_VD_DEV_NCC.CD_CTR_NCC = PDV_VD_DEV_NCC_PDV_VD.CD_CTR_NCC
          INNER JOIN PDV_VD AS PDV_VD_NOVO ON PDV_VD_NOVO.CD_VD = PDV_VD_DEV_NCC_PDV_VD.CD_VD
                                              AND PDV_VD_NOVO.CD_FILIAL = PDV_VD_DEV_NCC_PDV_VD.CD_FILIAL
                                              AND PDV_VD_NOVO.CD_EMP = PDV_VD_DEV_NCC_PDV_VD.CD_EMP
          INNER JOIN RC_CLI AS RC_CLI_NOVO ON PDV_VD_NOVO.CD_EMP = RC_CLI_NOVO.CD_EMP
                                              AND PDV_VD_NOVO.CD_CLI = RC_CLI_NOVO.CD_CLI
     WHERE PDV_VD_DEV_NCC.STS_NCC IN(1, 7)
     UNION ALL
     SELECT DISTINCT
            PDV_VD.CD_EMP,
            PDV_VD.CD_FILIAL,
            PDV_VD_DEV_NCC.CD_CTR_NCC,
            PDV_VD.CD_FILIAL AS CD_FILIAL_GEROU,
            PDV_VD_DEV_NCC.VLR_NCC AS VLR_DEVOLVIDO,
            GLB_USU.NM_USU,
            PDV_VD_DEV_NCC.DT_CAD,
            PDV_VD_DEV_NCC.STS_NCC,
            PDV_VD.DT_VD,
            PDV_VD.NR_ECF AS NR_ECF_GEROU,
            PDV_VD.CD_CX AS CX_GEROU,
            PDV_VD.VLR_LIQ_VD AS VLR_LIQ_VENDA_GEROU,
            RC_CLI.CD_CLI,
            ISNULL(RC_CLI.RZ_CLI, '') AS NM_CLI_GEROU,
            STS_NCC AS CD_MODALIDADE,
            V_PDV_VD_DEV_NCC_STATUS.DS_STS_NCC AS MODALIDADE,
            NULL AS DT_VD_CRED_NCC,
            '' AS NR_DOCUMENTO,
            0 AS CD_CX_CRED_NCC,
            0 AS VLR_LIQ_VD,
            0 AS CD_CLI_CRED_NCC,
            RC_CLI_NOVO.NM_FANT AS NM_CLI_USOU,
            0 AS CD_REGI,
            ISNULL(PDV_VD.CD_CONV, 0) AS CD_CONV,
            RC_VD_CONV_CRED.VLR_CRED AS VLR_NCC_USADO,
			PDV_VD_DEV_NCC.DT_CAD_REGISTRO,
			PDV_VD_DEV_NCC.TIPO_NCC
     FROM PDV_VD_DEV_NCC
          INNER JOIN PDV_VD_DEV_NCC_PDV_VD_DEV_EST_PROD_IMP AS NCC_DEV ON PDV_VD_DEV_NCC.CD_CTR_NCC = NCC_DEV.CD_CTR_NCC
          INNER JOIN PDV_VD ON NCC_DEV.CD_EMP = PDV_VD.CD_EMP
                               AND NCC_DEV.CD_FILIAL = PDV_VD.CD_FILIAL
                               AND NCC_DEV.CD_VD = PDV_VD.CD_VD
          INNER JOIN dbo.RC_CLI ON PDV_VD.CD_EMP = RC_CLI.CD_EMP
                                   AND PDV_VD.CD_CLI = RC_CLI.CD_CLI
          INNER JOIN dbo.GLB_USU ON PDV_VD_DEV_NCC.CD_USU = GLB_USU.CD_USU
          INNER JOIN V_PDV_VD_DEV_NCC_STATUS ON PDV_VD_DEV_NCC.STS_NCC = V_PDV_VD_DEV_NCC_STATUS.CD_STS_NCC
          INNER JOIN PDV_VD_DEV_NCC_LANC_CPL AS NCC_CPL ON PDV_VD_DEV_NCC.CD_CTR_NCC = NCC_CPL.CD_CTR_NCC
          INNER JOIN PDV_VD_DEV_NCC_LANC AS LANC ON NCC_CPL.CD_CTR_LANC_NCC = LANC.CD_CTR_LANC_NCC
          INNER JOIN PDV_VD_DEV_NCC_LANC_RC_VD_CONV_CRED AS RC_CRED ON LANC.CD_CTR_LANC_NCC = RC_CRED.CD_CTR_LANC_NCC
          INNER JOIN RC_VD_CONV_CRED ON RC_CRED.CD_CTR_CRED = RC_VD_CONV_CRED.CD_CTR_CRED
                                        AND RC_CRED.CD_CTR = RC_VD_CONV_CRED.CD_CTR
          INNER JOIN RC_VD_CONV ON RC_CRED.CD_CTR = RC_VD_CONV.CD_CTR
          INNER JOIN RC_CLI AS RC_CLI_NOVO ON RC_VD_CONV.CD_EMP = RC_CLI_NOVO.CD_EMP
                                              AND RC_VD_CONV.CD_CLI = RC_CLI_NOVO.CD_CLI
     WHERE PDV_VD_DEV_NCC.STS_NCC = 8
     UNION ALL
     SELECT DISTINCT
            PDV_VD.CD_EMP,
            PDV_VD.CD_FILIAL,
            PDV_VD_DEV_NCC.CD_CTR_NCC,
            PDV_VD.CD_FILIAL AS CD_FILIAL_GEROU,
            PDV_VD_DEV_NCC.VLR_NCC AS VLR_DEVOLVIDO,
            GLB_USU.NM_USU,
            PDV_VD_DEV_NCC.DT_CAD,
            PDV_VD_DEV_NCC.STS_NCC,
            PDV_VD.DT_VD,
            PDV_VD.NR_ECF AS NR_ECF_GEROU,
            PDV_VD.CD_CX AS CX_GEROU,
            PDV_VD.VLR_LIQ_VD AS VLR_LIQ_VENDA_GEROU,
            RC_CLI.CD_CLI,
            ISNULL(dbo.RC_CLI.RZ_CLI, '') AS NM_CLI_GEROU,
            STS_NCC AS CD_MODALIDADE,
            V_PDV_VD_DEV_NCC_STATUS.DS_STS_NCC AS MODALIDADE,
            NULL AS DT_VD_CRED_NCC,
            CONVERT(VARCHAR(10),RC_DEB.NR_DP) AS NR_DOCUMENTO,
            RC_DEB.PARC AS CD_CX_CRED_NCC,
            RC_CRED.VL_PGTO AS VLR_LIQ_VD,
            0 AS CD_CLI_CRED_NCC,
            RC_CLI_NOVO.NM_FANT AS NM_CLI_USOU,
            0 AS CD_REGI,
            ISNULL(PDV_VD.CD_CONV, 0) AS CD_CONV,
            RC_CRED.VL_PGTO AS VLR_NCC_USADO,
			PDV_VD_DEV_NCC.DT_CAD_REGISTRO,
			PDV_VD_DEV_NCC.TIPO_NCC
     FROM PDV_VD_DEV_NCC
          INNER JOIN PDV_VD_DEV_NCC_PDV_VD_DEV_EST_PROD_IMP AS NCC_DEV ON PDV_VD_DEV_NCC.CD_CTR_NCC = NCC_DEV.CD_CTR_NCC
          INNER JOIN PDV_VD ON NCC_DEV.CD_EMP = PDV_VD.CD_EMP
                               AND NCC_DEV.CD_FILIAL = PDV_VD.CD_FILIAL
                               AND NCC_DEV.CD_VD = PDV_VD.CD_VD
          INNER JOIN dbo.RC_CLI ON PDV_VD.CD_EMP = RC_CLI.CD_EMP
                                   AND PDV_VD.CD_CLI = RC_CLI.CD_CLI
          INNER JOIN dbo.GLB_USU ON PDV_VD_DEV_NCC.CD_USU = GLB_USU.CD_USU
          INNER JOIN V_PDV_VD_DEV_NCC_STATUS ON PDV_VD_DEV_NCC.STS_NCC = V_PDV_VD_DEV_NCC_STATUS.CD_STS_NCC
          INNER JOIN PDV_VD_DEV_NCC_LANC_CPL LANC_CPL ON PDV_VD_DEV_NCC.CD_CTR_NCC = LANC_CPL.CD_CTR_NCC
          INNER JOIN PDV_VD_DEV_NCC_LANC LANC ON LANC.CD_CTR_LANC_NCC = LANC_CPL.CD_CTR_LANC_NCC
          INNER JOIN PDV_VD_DEV_NCC_LANC_RC_CRED NCC_CRED ON LANC.CD_CTR_LANC_NCC = NCC_CRED.CD_CTR_LANC_NCC
          INNER JOIN RC_CRED ON NCC_CRED.CD_EMP = RC_CRED.CD_EMP
                                AND NCC_CRED.CD_FILIAL = RC_CRED.CD_FILIAL
                                AND NCC_CRED.CD_RC_DEB = RC_CRED.CD_RC_DEB
                                AND NCC_CRED.CD_DP_LANC = RC_CRED.CD_DP_LANC
          INNER JOIN RC_DEB ON RC_CRED.CD_EMP = RC_DEB.CD_EMP
                               AND RC_CRED.CD_FILIAL = RC_DEB.CD_FILIAL
                               AND RC_CRED.CD_RC_DEB = RC_DEB.CD_RC_DEB
          INNER JOIN RC_CLI AS RC_CLI_NOVO ON RC_DEB.CD_EMP = RC_CLI_NOVO.CD_EMP
                                              AND RC_DEB.CD_CLI = RC_CLI_NOVO.CD_CLI
     WHERE PDV_VD_DEV_NCC.STS_NCC = 4
     UNION ALL
     SELECT DISTINCT
            PDV_VD.CD_EMP,
            PDV_VD.CD_FILIAL,
            PDV_VD_DEV_NCC.CD_CTR_NCC,
            PDV_VD.CD_FILIAL AS CD_FILIAL_GEROU,
            PDV_VD_DEV_NCC.VLR_NCC AS VLR_DEVOLVIDO,
            GLB_USU.NM_USU,
            PDV_VD_DEV_NCC.DT_CAD,
            PDV_VD_DEV_NCC.STS_NCC,
            PDV_VD.DT_VD,
            PDV_VD.NR_ECF AS NR_ECF_GEROU,
            PDV_VD.CD_CX AS CX_GEROU,
            PDV_VD.VLR_LIQ_VD AS VLR_LIQ_VENDA_GEROU,
            RC_CLI.CD_CLI,
            ISNULL(dbo.RC_CLI.RZ_CLI, '') AS NM_CLI_GEROU,
            STS_NCC AS CD_MODALIDADE,
            V_PDV_VD_DEV_NCC_STATUS.DS_STS_NCC AS MODALIDADE,
            NULL AS DT_VD_CRED_NCC,
            RC_CREDIARIO_PARC.NR_FATURA AS NR_DOCUMENTO,
            RC_CREDIARIO_PARC.PARC_CRED AS CD_CX_CRED_NCC,
            0 AS VLR_LIQ_VD,
            0 AS CD_CLI_CRED_NCC,
            RC_CLI_NOVO.NM_FANT AS NM_CLI_USOU,
            0 AS CD_REGI,
            ISNULL(PDV_VD.CD_CONV, 0) AS CD_CONV,
            RC_CREDIARIO_PARC_CRED.VLR_CRED AS VLR_NCC_USADO,
			PDV_VD_DEV_NCC.DT_CAD_REGISTRO,
			PDV_VD_DEV_NCC.TIPO_NCC
     FROM PDV_VD_DEV_NCC
          INNER JOIN PDV_VD_DEV_NCC_PDV_VD_DEV_EST_PROD_IMP AS NCC_DEV ON PDV_VD_DEV_NCC.CD_CTR_NCC = NCC_DEV.CD_CTR_NCC
          INNER JOIN PDV_VD ON NCC_DEV.CD_EMP = PDV_VD.CD_EMP
                               AND NCC_DEV.CD_FILIAL = PDV_VD.CD_FILIAL
                               AND NCC_DEV.CD_VD = PDV_VD.CD_VD
          INNER JOIN RC_CLI ON PDV_VD.CD_EMP = RC_CLI.CD_EMP
                               AND PDV_VD.CD_CLI = RC_CLI.CD_CLI
          INNER JOIN GLB_USU ON PDV_VD_DEV_NCC.CD_USU = GLB_USU.CD_USU
          INNER JOIN V_PDV_VD_DEV_NCC_STATUS ON PDV_VD_DEV_NCC.STS_NCC = V_PDV_VD_DEV_NCC_STATUS.CD_STS_NCC
          INNER JOIN PDV_VD_DEV_NCC_LANC_CPL AS NCC_CPL ON PDV_VD_DEV_NCC.CD_CTR_NCC = NCC_CPL.CD_CTR_NCC
          INNER JOIN PDV_VD_DEV_NCC_LANC AS LANC ON NCC_CPL.CD_CTR_LANC_NCC = LANC.CD_CTR_LANC_NCC
          INNER JOIN PDV_VD_DEV_NCC_LANC_RC_CREDIARIO_PARC_CRED AS RC_CRED ON LANC.CD_CTR_LANC_NCC = RC_CRED.CD_CTR_LANC_NCC
          INNER JOIN RC_CREDIARIO_PARC_CRED ON RC_CRED.CD_CTR_CRED = RC_CREDIARIO_PARC_CRED.CD_CTR_CRED
                                               AND RC_CRED.CD_CTR = RC_CREDIARIO_PARC_CRED.CD_CTR
          INNER JOIN RC_CREDIARIO_PARC ON RC_CRED.CD_CTR = RC_CREDIARIO_PARC.CD_CTR
          INNER JOIN RC_CLI AS RC_CLI_NOVO ON RC_CREDIARIO_PARC.CD_EMP = RC_CLI_NOVO.CD_EMP
                                              AND RC_CREDIARIO_PARC.CD_CLI = RC_CLI_NOVO.CD_CLI
     WHERE PDV_VD_DEV_NCC.STS_NCC = 10
	 
	 --- linx Promo
	 UNION ALL
     SELECT DISTINCT
            PDV_VD.CD_EMP,
            PDV_VD.CD_FILIAL,
            PDV_VD_DEV_NCC.CD_CTR_NCC,
            PDV_VD.CD_FILIAL AS CD_FILIAL_GEROU,
            PDV_VD_DEV_NCC.VLR_NCC AS VLR_DEVOLVIDO,
            GLB_USU.NM_USU,
            PDV_VD_DEV_NCC.DT_CAD,
            PDV_VD_DEV_NCC.STS_NCC,
            PDV_VD.DT_VD,
            PDV_VD.NR_ECF AS NR_ECF_GEROU,
            PDV_VD.CD_CX AS CX_GEROU,
            PDV_VD.VLR_LIQ_VD AS VLR_LIQ_VENDA_GEROU,
            RC_CLI.CD_CLI,
            ISNULL(dbo.RC_CLI.RZ_CLI, '') AS NM_CLI_GEROU,
            STS_NCC AS CD_MODALIDADE,
            V_PDV_VD_DEV_NCC_STATUS.DS_STS_NCC AS MODALIDADE,
            NULL AS DT_VD_CRED_NCC,
            '' AS NR_DOCUMENTO,
            0 AS CD_CX_CRED_NCC,
            0 AS VLR_LIQ_VD,
            0 AS CD_CLI_CRED_NCC,
            '' AS NM_CLI_USOU,
            0 AS CD_REGI,
            ISNULL(PDV_VD.CD_CONV, 0) AS CD_CONV,  -- select * from V_PDV_VD_DEV_NCC_STATUS
            0 AS VLR_NCC_USADO,
			PDV_VD_DEV_NCC.DT_CAD_REGISTRO,
			PDV_VD_DEV_NCC.TIPO_NCC
    
  FROM PDV_VD_DEV_NCC
    
	 LEFT JOIN PDV_VD_DEV_NCC_PDV_VD AS LINX_PROMO ON 
		  PDV_VD_DEV_NCC.CD_EMP = LINX_PROMO.CD_EMP
                               AND PDV_VD_DEV_NCC.CD_FILIAL = LINX_PROMO.CD_FILIAL
							   AND PDV_VD_DEV_NCC.CD_CTR_NCC = LINX_PROMO.CD_CTR_NCC
				 
          INNER JOIN PDV_VD ON LINX_PROMO.CD_EMP = PDV_VD.CD_EMP
                               AND LINX_PROMO.CD_FILIAL = PDV_VD.CD_FILIAL
                               AND LINX_PROMO.CD_VD = PDV_VD.CD_VD
          INNER JOIN dbo.RC_CLI ON PDV_VD.CD_EMP = RC_CLI.CD_EMP
                                   AND PDV_VD.CD_CLI = RC_CLI.CD_CLI
          INNER JOIN dbo.GLB_USU ON PDV_VD_DEV_NCC.CD_USU = GLB_USU.CD_USU
          INNER JOIN V_PDV_VD_DEV_NCC_STATUS ON PDV_VD_DEV_NCC.STS_NCC = V_PDV_VD_DEV_NCC_STATUS.CD_STS_NCC

	WHERE  PDV_VD_DEV_NCC.TIPO_NCC = 12
  