 
IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[dbo].[V_BC_LANC_FILIAL]'))
DROP VIEW [dbo].[V_BC_LANC_FILIAL]
GO
GO
   
-- select * from V_BC_LANC_FILIAL where cd_bc_lanc = 1371388  
CREATE VIEW [dbo].[V_BC_LANC_FILIAL] AS  
	SELECT      
		 BC_LANC_BC_CHQ_LANC.CD_EMP,  
		 BC_LANC_BC_CHQ_LANC.CD_BC_LANC,   
		 'CHEQUE EMPRESA' AS DS_ORIGEM ,
		 ISNULL(CHQ_LANC.CD_FILIAL,0) as CD_FILIAL 
		-- 0 as CD_FILIAL
		 
	FROM 
	    BC_LANC INNER JOIN  BC_LANC_BC_CHQ_LANC ON
		BC_LANC_BC_CHQ_LANC.CD_EMP = BC_LANC.CD_EMP AND  
		BC_LANC_BC_CHQ_LANC.CD_BC_LANC = BC_LANC.CD_BC_LANC
	    LEFT OUTER JOIN BC_LANC_TRANSF ON  
		BC_LANC_BC_CHQ_LANC.CD_EMP = BC_LANC_TRANSF.CD_EMP AND  
		BC_LANC_BC_CHQ_LANC.CD_BC_LANC = BC_LANC_TRANSF.CD_BC_LANC_ORIG 
		
		LEFT JOIN CHQ_LANC ON 
		BC_LANC_BC_CHQ_LANC.CD_EMP = CHQ_LANC.CD_EMP AND 
		BC_LANC_BC_CHQ_LANC.CD_CHQ_LANC = CHQ_LANC.CD_CHQ_LANC
			 
	WHERE  
		BC_LANC_TRANSF.CD_BC_LANC_ORIG IS NULL  
	    AND YEAR( BC_LANC.DT_CAD) = CHQ_LANC.ANO
		  
	UNION ALL  
	SELECT  
		BC_LANC_CHQ_DEPOS.CD_EMP,  
		CD_BC_LANC,   
		'CHEQUE DEPOSITO',
		ISNULL(CHQ_DEPOS.CD_FILIAL,0) as CD_FILIAL  
	FROM  
		BC_LANC_CHQ_DEPOS
		LEFT JOIN CHQ_DEPOS ON 
		  BC_LANC_CHQ_DEPOS.CD_EMP = CHQ_DEPOS.CD_EMP AND  
		  BC_LANC_CHQ_DEPOS.ANO = CHQ_DEPOS.ANO AND 
		  BC_LANC_CHQ_DEPOS.CD_DEPOS = CHQ_DEPOS.CD_DEPOS  
	
	UNION ALL
	  
	SELECT  
		BC_LANC_CHQ_DESC.CD_EMP,  
		CD_BC_LANC,   
		'CHEQUE DESCONTO',
		ISNULL(CHQ_DESC.CD_FILIAL,0) as CD_FILIAL    
	FROM  
		BC_LANC_CHQ_DESC
		LEFT JOIN CHQ_DESC ON 
		  BC_LANC_CHQ_DESC.CD_EMP = CHQ_DESC.CD_EMP AND  
		  BC_LANC_CHQ_DESC.CD_DESC = CHQ_DESC.CD_DESC    
	
	UNION ALL  
	SELECT  
		CD_EMP,  
		CD_BC_LANC,   
		'CHEQUE ENVIO COBRANA\DESCONTO',
		0 AS CD_FILIAL     
	FROM  
		BC_LANC_CHQ_DEST_ENV 
		--CHQ_DEST_ENV NO TEM O CD_FILIAL,  SOMENTE TABELA CPL
		-- SE INSERIR DUPLICA REGISTRO
	
	UNION ALL  
	SELECT  
		CD_EMP,  
		CD_BC_LANC,   
		'CHEQUE ESTORNO',
		0 AS CD_FILIAL    
	FROM  
		BC_LANC_CHQ_DEST_ENV_CPL_ESTORNO 
		--CHQ_DEST_ENV_CPL_ESTORNO NO TEM O CD_FILIAL,  SOMENTE TABELA CPL
		-- SE INSERIR DUPLICA REGISTRO 
	
	UNION ALL  
	SELECT  
		CD_EMP,  
		CD_BC_LANC,   
		'CHEQUE DEVOLUO',
		0 AS CD_FILIAL    
	FROM  
		BC_LANC_CHQ_DEVO 
		-- CHQ_DEVO NO TEM O CD_FILIAL,  SOMENTE TABELA CPL
		-- SE INSERIR DUPLICA REGISTRO 
	
	UNION ALL  
	SELECT  
		CD_EMP,  
		CD_BC_LANC,   
		'CHEQUE REDEPOSITO',
		0 AS CD_FILIAL    
	FROM  
		BC_LANC_CHQ_REDEPOS
		--CHQ_REDEPOS  NO TEM O CD_FILIAL,  SOMENTE TABELA CPL
		-- SE INSERIR DUPLICA REGISTRO  
	
	UNION ALL  
	SELECT  
		CD_EMP,  
		CD_BC_LANC,   
		'RECEBIMENTO DUPLICATA' ,
		 RC_CRED_BC_LANC.CD_FILIAL   
	FROM  
		RC_CRED_BC_LANC  
	
	UNION ALL  
	SELECT  
	 CD_EMP,  
	 CD_BC_LANC,   
	 'PAGAMENTO DUPLICATA' ,
	 PG_DEB_BC_LANC.CD_FILIAL
	FROM  
		PG_DEB_BC_LANC  
	
	UNION ALL  
	SELECT  
		CD_EMP,  
		CD_BC_LANC,   
		'PAGAMENTO DUPLICATA EM LOTE',
		0 AS CD_FILIAL    
	FROM  
		PG_DEB_LOTE_BC_LANC 
		--PG_DEB_LOTE   NO TEM O CD_FILIAL,  SOMENTE TABELA CPL
		-- SE INSERIR DUPLICA REGISTRO  
	
	UNION ALL  
	SELECT  
		BC_LANC_CHQ_LANC_CUSTODIA.CD_EMP,  
		CD_BC_LANC,   
		'CHEQUE CUSTODIA',
		ISNULL(CHQ_LANC_CUSTODIA.CD_FILIAL,0 ) AS CD_FILIAL    
	FROM  
		BC_LANC_CHQ_LANC_CUSTODIA
		LEFT JOIN CHQ_LANC_CUSTODIA ON
		CHQ_LANC_CUSTODIA.CD_EMP = BC_LANC_CHQ_LANC_CUSTODIA.CD_EMP
		AND  CHQ_LANC_CUSTODIA.ANO = BC_LANC_CHQ_LANC_CUSTODIA.ANO
		AND CHQ_LANC_CUSTODIA.CD_CUSTODIA = BC_LANC_CHQ_LANC_CUSTODIA.CD_CUSTODIA
		
		  
	UNION ALL  
	SELECT  
		BC_LANC_CHQ_LANC.CD_EMP,  
		CD_BC_LANC,   
		'CHEQUE LOTE',
		ISNULL(CHQ_LANC.CD_FILIAL,0) AS CD_FILIAL    
	FROM  
		BC_LANC_CHQ_LANC  LEFT JOIN CHQ_LANC ON 
		BC_LANC_CHQ_LANC.CD_EMP = CHQ_LANC.CD_EMP
		AND BC_LANC_CHQ_LANC.ANO = CHQ_LANC.ANO
		AND BC_LANC_CHQ_LANC.CD_CHQ_LANC = CHQ_LANC.CD_CHQ_LANC
			
	UNION ALL  
	SELECT  
		CD_EMP,  
		CD_BC_LANC_ORIG,   
		'TRANSFERENCIA ENTRE CONTAS ORIGEM',
		0 AS CD_FILIAL    
	FROM  
		BC_LANC_TRANSF  
	    -- NO EXISTE CD_FILIAL ENVOLVIDO NESTE PROCESSO

	UNION ALL  
	SELECT  
		BC_LANC_TRANSF.CD_EMP,  
		CD_BC_LANC_DEST,   
		'TRANSFERENCIA ENTRE CONTAS DESTINO',
		ISNULL(BC_LANC_PDV_VD_FECHA_MOV_TES_DEPOSITO.CD_FILIAL,0 )CD_FILIAL
	FROM  
		BC_LANC_TRANSF 
	  
		LEFT JOIN BC_LANC_PDV_VD_FECHA_MOV_TES_DEPOSITO ON
	    BC_LANC_TRANSF.CD_EMP     = BC_LANC_PDV_VD_FECHA_MOV_TES_DEPOSITO.CD_EMP AND
	    BC_LANC_TRANSF.CD_BC_LANC_DEST = BC_LANC_PDV_VD_FECHA_MOV_TES_DEPOSITO.CD_BC_LANC_CRED 
		 
	
	UNION ALL  
	SELECT  
		CD_EMP,  
		CD_BC_LANC,   
		'RECEBIMENTO DE DUPLICATAS EM LOTE',
		0 AS CD_FILIAL    
	FROM  
		RC_CRED_LOTE_BC_LANC 
		--RC_CRED_LOTE  NO TEM O CD_FILIAL,  SOMENTE TABELA CPL
		-- SE INSERIR DUPLICA REGISTRO  
	 
	  
	UNION ALL  
	SELECT  
		CD_EMP,  
		CD_BC_LANC,   
		'RECEBIMENTO DE CHEQUE EM COBRANA',
		0 AS CD_FILIAL    
	FROM  
		BC_LANC_CHQ_DEST_ENV_CPL  
	    -- CHQ_DEST_ENV_CPL NO TEM O CD_FILIAL,  SOMENTE TABELA CPL
		-- SE INSERIR DUPLICA REGISTRO  
	
	UNION ALL
	SELECT
	  CD_EMP,  
	  CD_BC_LANC,   
	 'BANCARIO MANUAL',
		0 AS CD_FILIAL   
	FROM 
		BC_LANC 
	WHERE 
		ORIG_LANC = 1
	    -- NO EXISTE CD_FILIAL ENVOLVIDO NESTE PROCESSO

	UNION ALL
	SELECT
	  CD_EMP,  
	  CD_BC_LANC,   
	 'RECEBIMENTO CARTAO CREDITO\DEBITO',
		0 AS CD_FILIAL   
	FROM 
		BC_LANC_RC_ADM_CARTAO_MOV
		-- NO EXISTE CD_FILIAL ENVOLVIDO NESTE PROCESSO
		
 
  

 