IF NOT EXISTS(SELECT 1 FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME='INTEGRA_ECOMMERCE_PRODUTO') 
BEGIN
CREATE TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO](
	[CD_EMP] [int] NOT NULL,
	[CD_PROD] [int] NOT NULL,
	[EAN] [varchar](20) NULL,
	[TITULO] [varchar](100) NULL,
	[DESCRICAO] [varchar](150) NULL,
	[DETALHES] [varchar](200) NULL,
	[PALAVRAS_CHAVE] [varchar](100) NULL,
	[PESO] [money] NOT NULL,
	[ALTURA] [money] NOT NULL,
	[LARGURA] [money] NOT NULL,
	[PROFUNDIDADE] [money] NOT NULL,
	[ATIVO] [bit] NOT NULL,
	[MEDICAMENTO] [bit] NOT NULL,
	[ANTIBIOTICO] [bit] NOT NULL,
	[PSICOTROPICO] [bit] NOT NULL,
	[GENERICO] [bit] NOT NULL,
	[SIMILAR] [bit] NOT NULL,
	[CONTROLADO] [bit] NOT NULL,
	[TARJADO] [bit] NOT NULL,
	[TARJA_PRETA] [bit] NOT NULL,
	[TERMOSENSIVEL] [bit] NOT NULL,
	[CODIGO_MS] [varchar](20) NULL,
	[PROIBE_VENDA_SITE] [bit] NOT NULL,
	[URL_IMAGEM] [varchar](255) NULL,
	[URL_VIDEO] [varchar](255) NULL,
	[URL_FICHA_TECNICA] [varchar](255) NULL,
	[PRODUTO_ENVIADO] [tinyint] NOT NULL,
 CONSTRAINT [PK_INTEGRA_ECOMMERCE_PRODUTO_CD_PROD] PRIMARY KEY CLUSTERED 
(
	[CD_EMP] ASC,
	[CD_PROD] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, FILLFACTOR = 70) ON [PRIMARY]
) ON [PRIMARY];


ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [PESO];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [ALTURA];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [LARGURA];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [PROFUNDIDADE];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [ATIVO];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [MEDICAMENTO];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [ANTIBIOTICO];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [PSICOTROPICO];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [GENERICO];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [SIMILAR];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [CONTROLADO];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [TARJADO];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [TARJA_PRETA];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [TERMOSENSIVEL];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  DEFAULT ((0)) FOR [PROIBE_VENDA_SITE];

ALTER TABLE [dbo].[INTEGRA_ECOMMERCE_PRODUTO] ADD  CONSTRAINT [DF_INTEGRA_ECOMMERCE_PRODUTO_PRODUTO_ENVIADO]  DEFAULT ((0)) FOR [PRODUTO_ENVIADO];
END
