/****** Object:  Table [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN]    Script Date: 06/23/2013 11:03:54 ******/
IF  NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN]') AND type in (N'U'))
begin
	CREATE TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN](
		[CD_EMP] [int] NOT NULL,
		[CD_REGIAO_FISCAL] [int] NOT NULL,
		[CD_FORN] [int] NOT NULL,
		[CD_PROD] [int] NOT NULL,
		[CD_TRIB] [int] NOT NULL,
		[TP_MOV] [int] NOT NULL,
		[TP_TRANSA] [int] NOT NULL,
		[PERC_RED] [money] NOT NULL,
		[TP_SUBS] [money] NOT NULL,
		[VLR_PAUTA_IVA] [money] NOT NULL,
		[PERC_ICMS] [money] NOT NULL,
		[TP_RED_BASE_IMP] [money] NOT NULL,
		[PERC_ICMS_EST] [money] NOT NULL,
		[PERC_RED_SUBS_TRIB] [money] NULL,
		[PERC_RED_ESTORNO] [money] NULL,
		[DT_CAD] [datetime] NULL,
		[CD_USU] [int] NULL,
		[CST_PIS] [int] NULL,
		[CST_COFINS] [int] NULL,
		[PERC_REPASSE] [money] NULL,
		[PERC_IBPT] [money] NULL,
	 CONSTRAINT [PK_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] PRIMARY KEY CLUSTERED 
	(
		[CD_EMP] ASC,
		[CD_REGIAO_FISCAL] ASC,
		[CD_FORN] ASC,
		[CD_PROD] ASC,
		[CD_TRIB] ASC,
		[TP_MOV] ASC,
		[TP_TRANSA] ASC
	)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
	) ON [PRIMARY]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_EST_PROD] FOREIGN KEY([CD_EMP], [CD_PROD])
	REFERENCES [dbo].[EST_PROD] ([CD_EMP], [CD_PROD])

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] CHECK CONSTRAINT [FK_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_EST_PROD]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_EST_TRIB] FOREIGN KEY([CD_TRIB])
	REFERENCES [dbo].[EST_TRIB] ([CD_TRIB])

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] CHECK CONSTRAINT [FK_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_EST_TRIB]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PG_FORN] FOREIGN KEY([CD_EMP], [CD_FORN])
	REFERENCES [dbo].[PG_FORN] ([CD_EMP], [CD_FORN])

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] CHECK CONSTRAINT [FK_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PG_FORN]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PRC_REGIAO_FISCAL] FOREIGN KEY([CD_REGIAO_FISCAL])
	REFERENCES [dbo].[PRC_REGIAO_FISCAL] ([CD_REGIAO_FISCAL])

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] CHECK CONSTRAINT [FK_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PRC_REGIAO_FISCAL]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_CD_EMP]  DEFAULT ((0)) FOR [CD_EMP]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_CD_REGIAO_FISCAL]  DEFAULT ((0)) FOR [CD_REGIAO_FISCAL]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_CD_FORN]  DEFAULT ((0)) FOR [CD_FORN]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_CD_PROD]  DEFAULT ((0)) FOR [CD_PROD]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_CD_TRIB]  DEFAULT ((0)) FOR [CD_TRIB]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_TP_MOV]  DEFAULT ((0)) FOR [TP_MOV]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_TP_TRANSA]  DEFAULT ((0)) FOR [TP_TRANSA]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PERC_RED]  DEFAULT ((0)) FOR [PERC_RED]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_TP_SUBS]  DEFAULT ((0)) FOR [TP_SUBS]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_VLR_PAUTA_IVA]  DEFAULT ((0)) FOR [VLR_PAUTA_IVA]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PERC_ICMS]  DEFAULT ((0)) FOR [PERC_ICMS]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_TP_RED_BASE_IMP]  DEFAULT ((0)) FOR [TP_RED_BASE_IMP]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PERC_ICMS_EST]  DEFAULT ((0)) FOR [PERC_ICMS_EST]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PERC_RED_SUBS_TRIB]  DEFAULT ((0)) FOR [PERC_RED_SUBS_TRIB]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PERC_RED_ESTORNO]  DEFAULT ((0)) FOR [PERC_RED_ESTORNO]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_CD_USU]  DEFAULT ((0)) FOR [CD_USU]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_CST_PIS]  DEFAULT ((0)) FOR [CST_PIS]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_CST_COFINS]  DEFAULT ((0)) FOR [CST_COFINS]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PERC_REPASSE]  DEFAULT ((0)) FOR [PERC_REPASSE]

	ALTER TABLE [dbo].[EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN] ADD  CONSTRAINT [DF_EST_PROD_PRC_REGIAO_FISCAL_TRIB_FORN_PERC_IBPT]  DEFAULT ((0)) FOR [PERC_IBPT]
end

