CREATE TABLE [dbo].[TRILHO_PROD_EXCESSO](
	[DT_MOV] [datetime] NOT NULL,
	[CD_EMP] [int] NOT NULL,
	[CD_CTR_DEPO] [int] NOT NULL,
	[CD_FILIAL] [int] NOT NULL,
	[CD_PROD] [int] NOT NULL,
	[DS_PROD] [varchar](150) NULL,
	[DS_ARV_MERC_LINHA] [varchar](150) NULL,
	[ESEG] [money] NOT NULL,
	[EMAX] [money] NOT NULL,
	[QTDE_FACEAMENTO] [money] NOT NULL,
	[QTDE_FINANCIADO] [money] NOT NULL,
	[QTDE_LIMITADOR] [money] NOT NULL,
	[VLR_EXCESSO] [money] NOT NULL,
	[COBERTURA] [money] NOT NULL,
	[QT_EST] [money] NOT NULL,
	[QTDE_EMAX] [money] NOT NULL,
	[EXCESSO] [money] NOT NULL,
	[QT_EST_ATU] [money] NOT NULL,
	[QT_PEND_ENT] [money] NOT NULL,
	[QT_PEND_SAI] [money] NOT NULL,
	[MEDIAF] [money] NOT NULL,
	[VLR_CUSTO] [money] NOT NULL,
	[VLR_TABELA] [money] NOT NULL,
	[CD_SIGLA] [int] NOT NULL,
	[CD_FABRIC] [int] NOT NULL,
	[CD_ARV_MERC_LINHA] [int] NOT NULL,
	[QTDE_MES_VENDA_FECHADO] [int] NOT NULL,
 CONSTRAINT [PK_TRILHO_PROD_EXCESSO] PRIMARY KEY CLUSTERED 
(
	[DT_MOV] ASC,
	[CD_PROD] ASC,
	[CD_FILIAL] ASC,
	[CD_CTR_DEPO] ASC,
	[CD_EMP] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

SET ANSI_PADDING OFF
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_CD_EMP]  DEFAULT ((0)) FOR [CD_EMP]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_CD_CTR_DEPO]  DEFAULT ((0)) FOR [CD_CTR_DEPO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_CD_FILIAL]  DEFAULT ((0)) FOR [CD_FILIAL]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_CD_PROD]  DEFAULT ((0)) FOR [CD_PROD]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_DS_PROD]  DEFAULT ('') FOR [DS_PROD]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_DS_ARV_MERC_LINHA]  DEFAULT ('') FOR [DS_ARV_MERC_LINHA]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_ESEG]  DEFAULT ((0)) FOR [ESEG]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_EMAX]  DEFAULT ((0)) FOR [EMAX]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_QTDE_FACEAMENTO]  DEFAULT ((0)) FOR [QTDE_FACEAMENTO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_QTDE_FINANCIADO]  DEFAULT ((0)) FOR [QTDE_FINANCIADO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_QTDE_LIMITADOR]  DEFAULT ((0)) FOR [QTDE_LIMITADOR]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_VLR_EXCESSO]  DEFAULT ((0)) FOR [VLR_EXCESSO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_COBERTURA]  DEFAULT ((0)) FOR [COBERTURA]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_QT_EST]  DEFAULT ((0)) FOR [QT_EST]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_QTDE_EMAX]  DEFAULT ((0)) FOR [QTDE_EMAX]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_EXCESSO]  DEFAULT ((0)) FOR [EXCESSO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_QT_EST_ATU]  DEFAULT ((0)) FOR [QT_EST_ATU]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_QT_PEND_ENT]  DEFAULT ((0)) FOR [QT_PEND_ENT]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_QT_PEND_SAI]  DEFAULT ((0)) FOR [QT_PEND_SAI]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_MEDIAF]  DEFAULT ((0)) FOR [MEDIAF]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_VLR_CUSTO]  DEFAULT ((0)) FOR [VLR_CUSTO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_VLR_TABELA]  DEFAULT ((0)) FOR [VLR_TABELA]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_CD_SIGLA]  DEFAULT ((0)) FOR [CD_SIGLA]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_CD_FABRIC]  DEFAULT ((0)) FOR [CD_FABRIC]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_CD_ARV_MERC_LINHA]  DEFAULT ((0)) FOR [CD_ARV_MERC_LINHA]
GO

ALTER TABLE [dbo].[TRILHO_PROD_EXCESSO] ADD  CONSTRAINT [DF_TRILHO_PROD_EXCESSO_QTDE_MES_VENDA_FECHADO]  DEFAULT ((0)) FOR [QTDE_MES_VENDA_FECHADO]
GO


