CREATE TABLE [dbo].[TRILHO_PROD_NECESSIDADE](
	[DT_MOV] [datetime] NOT NULL,
	[CD_EMP] [int] NOT NULL,
	[CD_CTR_DEPO] [int] NOT NULL,
	[CD_FILIAL] [int] NOT NULL,
	[CD_PROD] [int] NOT NULL,
	[QT_EST] [money] NOT NULL,
	[QT_EST_PEND] [money] NOT NULL,
	[ESEG] [money] NOT NULL,
	[EMAX] [money] NOT NULL,
	[MEDIAF] [money] NOT NULL,
	[NECESSIDADE] [money] NOT NULL,
	[QTDE_FACEAMENTO] [money] NOT NULL,
	[QTDE_FINANCIADO] [money] NOT NULL,
	[QTDE_LIMITADOR] [money] NOT NULL,
	[NECESSIDADE_FACEAMENTO] [money] NOT NULL,
	[NECESSIDADE_FINANCIADO] [money] NOT NULL,
	[NECESSIDADE_LIMITADOR] [money] NOT NULL,
 CONSTRAINT [PK_TRILHO_PROD_NECESSIDADE] PRIMARY KEY CLUSTERED 
(
	[DT_MOV] ASC,
	[CD_PROD] ASC,
	[CD_FILIAL] ASC,
	[CD_CTR_DEPO] ASC,
	[CD_EMP] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_CD_EMP]  DEFAULT ((0)) FOR [CD_EMP]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_CD_CTR_DEPO]  DEFAULT ((0)) FOR [CD_CTR_DEPO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_CD_FILIAL]  DEFAULT ((0)) FOR [CD_FILIAL]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_CD_PROD]  DEFAULT ((0)) FOR [CD_PROD]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_QT_EST]  DEFAULT ((0)) FOR [QT_EST]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_QT_EST_PEND]  DEFAULT ((0)) FOR [QT_EST_PEND]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_ESEG]  DEFAULT ((0)) FOR [ESEG]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_EMAX]  DEFAULT ((0)) FOR [EMAX]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_MEDIAF]  DEFAULT ((0)) FOR [MEDIAF]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_NECESSIDADE]  DEFAULT ((0)) FOR [NECESSIDADE]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_QTDE_FACEAMENTO]  DEFAULT ((0)) FOR [QTDE_FACEAMENTO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_QTDE_FINANCIADO]  DEFAULT ((0)) FOR [QTDE_FINANCIADO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_QTDE_LIMITADOR]  DEFAULT ((0)) FOR [QTDE_LIMITADOR]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_NECESSIDADE_FACEAMENOT]  DEFAULT ((0)) FOR [NECESSIDADE_FACEAMENTO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_NECESSIDADE_FINANCIADO]  DEFAULT ((0)) FOR [NECESSIDADE_FINANCIADO]
GO

ALTER TABLE [dbo].[TRILHO_PROD_NECESSIDADE] ADD  CONSTRAINT [DF_TRILHO_PROD_NECESSIDADE_NECESSIDADE_LIMITADOR]  DEFAULT ((0)) FOR [NECESSIDADE_LIMITADOR]
GO


