IF OBJECT_ID ('P_PDV_VD_IT_VINC_TBL_DESC') IS NOT NULL
BEGIN
	DROP PROCEDURE P_PDV_VD_IT_VINC_TBL_DESC
END

GO

CREATE PROCEDURE P_PDV_VD_IT_VINC_TBL_DESC @CD_EMP AS INT, @CD_FILIAL AS INT, @CD_VD AS INT, @CD_IT AS INT, @TP_TBL_DESC AS VARCHAR(20), @CD_TBL_DESC AS INT
AS
BEGIN

UPDATE
	PDV_VD_IT
SET
	VLR_DESC_TOT_RAT = 0
WHERE
	CD_EMP = @CD_EMP
	AND CD_FILIAL = @CD_FILIAL
	AND CD_VD = @CD_VD

IF @TP_TBL_DESC = 'DESC_QTDE'
BEGIN

	IF NOT EXISTS (SELECT * FROM PDV_VD_IT_EST_PROD_TBL_DESC WHERE CD_EMP = @CD_EMP AND CD_FILIAL = @CD_FILIAL AND CD_VD = @CD_VD AND CD_IT = @CD_IT AND CD_TBL_DESC = @CD_TBL_DESC)
	BEGIN

		DECLARE @PERC_DESC MONEY

		SET @PERC_DESC = 0
		SELECT
			@PERC_DESC = PERC_DESC_QTDE
		FROM
			EST_PROD_PRECO_DESC_QTDE T
			INNER JOIN PDV_VD_IT IT ON
				IT.CD_EMP = @CD_EMP
				AND IT.CD_FILIAL = @CD_FILIAL
				AND IT.CD_VD = @CD_VD
				AND IT.CD_IT = @CD_IT
			INNER JOIN EST_PROD_PRECO_DESC_QTDE_CPL TC ON
				T.CD_PRECO_DESC_QTDE = TC.CD_PRECO_DESC_QTDE
				AND IT.CD_PROD = TC.CD_PROD
				AND IT.CD_EMP = TC.CD_EMP
				AND IT.QT_IT = TC.QT_PROD
			
		INSERT INTO 
			PDV_VD_IT_EST_PROD_TBL_DESC (CD_EMP,CD_FILIAL,CD_VD,CD_IT,CD_TBL_DESC,PERC_DESC)
		VALUES
			(@CD_EMP,@CD_FILIAL,@CD_VD,@CD_IT,@CD_TBL_DESC,@PERC_DESC)
	END
	
END

IF @TP_TBL_DESC = 'LEVE_X_PAG_Y'
BEGIN

	IF NOT EXISTS (SELECT * FROM PDV_VD_IT_EST_PROD_TBL_DESC_QTDE WHERE CD_EMP = @CD_EMP AND CD_FILIAL = @CD_FILIAL AND CD_VD = @CD_VD AND CD_IT = @CD_IT AND CD_TBL_DESC_QTDE = @CD_TBL_DESC)
	BEGIN
		INSERT INTO
			PDV_VD_IT_EST_PROD_TBL_DESC_QTDE (CD_EMP,CD_FILIAL,CD_VD,CD_IT,CD_TBL_DESC_QTDE,PERC_DESC)
		VALUES
			(@CD_EMP,@CD_FILIAL,@CD_VD,@CD_IT,@CD_TBL_DESC,99.99)
	END

END

IF @TP_TBL_DESC = 'LEVE_X_GANHE_Y'
BEGIN

	IF NOT EXISTS (SELECT * FROM PDV_VD_IT_PDV_CAMPANHA_ADICIONAIS WHERE CD_EMP = @CD_EMP AND CD_FILIAL = @CD_FILIAL AND CD_VD = @CD_VD AND CD_IT = @CD_IT AND CD_CAMPANHA_ADIC = @CD_TBL_DESC)
	BEGIN
		INSERT INTO 
			PDV_VD_IT_PDV_CAMPANHA_ADICIONAIS (CD_EMP,CD_FILIAL,CD_VD,CD_IT,CD_CAMPANHA_ADIC,PERC_DESC)
		VALUES (@CD_EMP,@CD_FILIAL,@CD_VD,@CD_IT,@CD_TBL_DESC,99.99)
	END

END
END
