IF NOT EXISTS (SELECT * FROM SYS.TABLES WHERE NAME = 'EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL')
BEGIN

CREATE TABLE [dbo].[EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL](
	[CD_EMP] [int] NOT NULL,
	[CD_CONV_PBM] [int] NOT NULL,
	[CD_FILIAL] [int] NOT NULL,
 CONSTRAINT [PK_EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL] PRIMARY KEY CLUSTERED 
(
	[CD_EMP] ASC,
	[CD_CONV_PBM] ASC,
	[CD_FILIAL] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, FILLFACTOR = 80) ON [PRIMARY]) ON [PRIMARY]
 
END

GO


IF NOT EXISTS (SELECT * FROM SYS.foreign_keys WHERE NAME = 'FK_EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL_EST_PROD_PRECO_DESC_QTDE_PBM')
BEGIN
	ALTER TABLE [dbo].[EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL_EST_PROD_PRECO_DESC_QTDE_PBM] FOREIGN KEY([CD_EMP], [CD_CONV_PBM])
	REFERENCES [dbo].[EST_PROD_PRECO_DESC_QTDE_PBM] ([CD_EMP], [CD_CONV_PBM])
	ON UPDATE CASCADE
	ON DELETE CASCADE

	ALTER TABLE [dbo].[EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL] CHECK CONSTRAINT [FK_EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL_EST_PROD_PRECO_DESC_QTDE_PBM]
END
GO

IF NOT EXISTS (SELECT * FROM SYS.foreign_keys WHERE NAME = 'FK_EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL_PRC_FILIAL')
BEGIN
	ALTER TABLE [dbo].[EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL_PRC_FILIAL] FOREIGN KEY([CD_EMP], [CD_FILIAL])
	REFERENCES [dbo].[PRC_FILIAL] ([CD_EMP], [CD_FILIAL])

	ALTER TABLE [dbo].[EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL] CHECK CONSTRAINT [FK_EST_PROD_PRECO_DESC_QTDE_PBM_PRC_FILIAL_PRC_FILIAL]
END
GO