/****** Object:  View [dbo].[V_CHQ_LANC_CPL_HISTORICO]    Script Date: 08/31/2013 17:26:31 ******/
IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[dbo].[V_CHQ_LANC_CPL_HISTORICO]'))
DROP VIEW [dbo].[V_CHQ_LANC_CPL_HISTORICO]
GO
GO
GO
CREATE VIEW V_CHQ_LANC_CPL_HISTORICO AS
SELECT 
	CHQ_DEPOS_CPL.CD_EMP,
	CHQ_DEPOS_CPL.CD_CHQ,
	CHQ_DEPOS.ANO, 
	CHQ_DEPOS.CD_DEPOS AS CD_TRANSACAO, 
	CHQ_DEPOS.DT_DEPOS AS DT_TRANSACAO,  
	CONVERT(VARCHAR(100),BC_CONTAS.NR_CNT) + ' - ' + CONVERT(VARCHAR(100),BC_CONTAS.CD_BC) AS HISTORICO,
	'DEPOSITO' AS TRANSACAO
FROM 
	CHQ_DEPOS_CPL INNER JOIN CHQ_DEPOS ON  
	CHQ_DEPOS_CPL.CD_EMP = CHQ_DEPOS.CD_EMP AND  
	CHQ_DEPOS_CPL.ANO = CHQ_DEPOS.ANO AND 
	CHQ_DEPOS_CPL.CD_DEPOS = CHQ_DEPOS.CD_DEPOS  
	INNER JOIN BC_CONTAS ON  
	CHQ_DEPOS.CD_EMP = BC_CONTAS.CD_EMP AND  
	CHQ_DEPOS.CD_CNT = BC_CONTAS.CD_CNT  
UNION ALL
SELECT 
	CD_EMP,
	CD_CHQ,
	0 AS ANO,
	CD_DEVO, 
	DT_DEVO, 
	DS_HIST,
	'DEVOLUCAO' AS TRANSACAO
FROM 
	V_CHQ_DEPOS_CHQ_REDEPOS 
UNION ALL
SELECT 
	CHQ_REDEPOS.CD_EMP, 
	CHQ_REDEPOS.CD_CHQ,
	0 AS ANO,
	CHQ_REDEPOS.CD_REDEPOS,  
	CHQ_REDEPOS.DT_REDEPOS, 
	CONVERT(VARCHAR(100),BC_CONTAS.NR_CNT) + ' - ' + CONVERT(VARCHAR(100),BC_CONTAS.CD_BC) AS HIST,
	'REDEPOSITO' AS TRANSACAO
FROM 
	CHQ_REDEPOS INNER JOIN BC_LANC_CHQ_REDEPOS ON  
	CHQ_REDEPOS.CD_EMP = BC_LANC_CHQ_REDEPOS.CD_EMP AND  
	CHQ_REDEPOS.CD_REDEPOS = BC_LANC_CHQ_REDEPOS.CD_REDEPOS 
	INNER JOIN BC_LANC ON  
	BC_LANC_CHQ_REDEPOS.CD_EMP = BC_LANC.CD_EMP AND  
	BC_LANC_CHQ_REDEPOS.CD_BC_LANC = BC_LANC.CD_BC_LANC 
	INNER JOIN BC_CONTAS ON  
	BC_LANC.CD_EMP = BC_CONTAS.CD_EMP AND  
	BC_LANC.CD_CNT = BC_CONTAS.CD_CNT  
WHERE
	BC_LANC.TP_LANC =0
UNION ALL
SELECT 
	CHQ_DEST_ENV_CPL.CD_EMP,
	CHQ_DEST_ENV_CPL.CD_CHQ,
	CHQ_DEST_ENV_CPL.ANO_ENV, 
	CHQ_DEST_ENV_CPL.CD_ENV,  
	CHQ_DEST_ENV.DT_ENV, 
	CHQ_DEST.NM_DEST AS HIST,
	'ENVIO A TERCEIROS' AS TRANSACAO 
FROM 
	CHQ_DEST_ENV_CPL INNER JOIN CHQ_DEST_ENV  ON
	CHQ_DEST_ENV_CPL.CD_EMP = CHQ_DEST_ENV.CD_EMP AND 
	CHQ_DEST_ENV_CPL.ANO_ENV = CHQ_DEST_ENV.ANO_ENV AND  
	CHQ_DEST_ENV_CPL.CD_ENV = CHQ_DEST_ENV.CD_ENV 
	INNER JOIN CHQ_DEST  ON
	CHQ_DEST_ENV.CD_EMP = CHQ_DEST.CD_EMP AND  
	CHQ_DEST_ENV.CD_DEST = CHQ_DEST.CD_DEST 
UNION ALL
SELECT  
	A.CD_EMP, 
	A.CD_CHQ,
	A.ANO, 
	A.CD_CUSTODIA, 
	A.DT_ESTORNO,  
	E.NM_DEST AS HIST,
	'CUSTODIA' AS TRANSACAO
FROM  
	CHQ_LANC_CUSTODIA_CPL_ESTORNO A INNER JOIN CHQ_DEST E ON 
	A.CD_EMP = E.CD_EMP AND 
	A.CD_DEST = E.CD_DEST 
UNION ALL
SELECT  
	CHQ_DESC_CPL.CD_EMP,
	CHQ_DESC_CPL.CD_CHQ,
	0 AS ANO,
	CHQ_DESC.CD_DESC, 
	CHQ_DESC.DT_CAD, 
	CHQ_DEST.NM_DEST AS HISTORICO,
	'DESCONTO' AS TRANSACAO 
FROM 
	CHQ_DESC INNER JOIN CHQ_DESC_CPL ON
	CHQ_DESC.CD_EMP = CHQ_DESC_CPL.CD_EMP   AND 
	CHQ_DESC.CD_DESC = CHQ_DESC_CPL.CD_DESC  
	INNER JOIN CHQ_DEST ON
	CHQ_DESC.CD_EMP = CHQ_DEST.CD_EMP   AND 
	CHQ_DESC.CD_DEST = CHQ_DEST.CD_DEST   
